import { ReferenceMapKey } from "../declare";
export declare type MultipleFulfillFunction<T> = () => T[] | Promise<T[]>;
export declare type MultipleFulfillKeyExtractor<K, T> = (element: T) => K;
export declare type MultipleVerifyFunction = () => boolean | Promise<boolean>;
export declare type MultipleReferenceFulfillerResultElement<K, T> = {
    readonly key: K;
    readonly value: T;
};
export declare class MultipleReferenceFulfiller<K extends ReferenceMapKey = string, T extends any = any> {
    static create<K extends ReferenceMapKey = string, T extends any = any>(fulfiller: MultipleFulfillFunction<T>, keyExtractor: MultipleFulfillKeyExtractor<K, T>): MultipleReferenceFulfiller<K, T>;
    private readonly _fulfiller;
    private readonly _keyExtractor;
    private _verifier?;
    private constructor();
    withVerify(verifier: MultipleVerifyFunction): this;
    shouldFulfillWith(): Promise<boolean>;
    execute(): Promise<Array<MultipleReferenceFulfillerResultElement<K, T>>>;
}
