import { ReferenceMapKey } from "../declare";
export declare type NamedFulfillFunction<K, T> = (key: K) => T | Promise<T>;
export declare type NamedFulfillVerifyFunction<K> = (key: K) => boolean | Promise<boolean>;
export declare class NamedReferenceFulfiller<K extends ReferenceMapKey = string, T extends any = any> {
    static create<K extends ReferenceMapKey = string, T extends any = any>(fulfiller: NamedFulfillFunction<K, T>): NamedReferenceFulfiller<K, T>;
    private readonly _fulfiller;
    private _verifier?;
    private constructor();
    withVerify(verifier: NamedFulfillVerifyFunction<K>): this;
    shouldFulfillWith(key: K): Promise<boolean>;
    execute(key: K): Promise<T>;
}
