"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.NamedReferenceFulfiller = void 0;
class NamedReferenceFulfiller {
    constructor(fulfiller) {
        this._fulfiller = fulfiller;
    }
    static create(fulfiller) {
        return new NamedReferenceFulfiller(fulfiller);
    }
    withVerify(verifier) {
        this._verifier = verifier;
        return this;
    }
    shouldFulfillWith(key) {
        return __awaiter(this, void 0, void 0, function* () {
            if (typeof this._verifier !== 'function') {
                return true;
            }
            const verifyResult = yield Promise.resolve(this._verifier(key));
            return Boolean(verifyResult);
        });
    }
    execute(key) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield Promise.resolve(this._fulfiller(key));
            return result;
        });
    }
}
exports.NamedReferenceFulfiller = NamedReferenceFulfiller;
