import { ReferenceMapKey } from "./declare";
import { MultipleReferenceFulfiller } from "./fulfiller/multiple";
import { NamedReferenceFulfiller } from "./fulfiller/named";
export declare class ReferenceMap<K extends ReferenceMapKey = string, T extends any = any> {
    static create<K extends ReferenceMapKey = string, T extends any = any>(): ReferenceMap<K, T>;
    private _itemMap;
    private readonly _namedFulfillers;
    private constructor();
    fulfillItemWith(fulfiller: NamedReferenceFulfiller<K, T>): this;
    ensureItemOrDefault(key: K, defaultItem: T): T;
    ensureItemOrUndefined(key: K): T | undefined;
    ensureItemOrNull(key: K): T | null;
    reset(key: K): this;
    getItemOrDefault(key: K, defaultItem: T): Promise<T>;
    getItemOrUndefined(key: K): Promise<T | undefined>;
    getItemOrNull(key: K): Promise<T | null>;
    refreshItem(key: K): Promise<boolean>;
    batchWith(fulfiller: MultipleReferenceFulfiller<K, T>): Promise<boolean>;
    fulfillItem(key: K): Promise<boolean>;
}
